<?php

namespace WPRuby_CAA\Core\App\Backend\Endpoints;

use WPRuby_CAA\Core\Constants;
use WPRuby_CAA\Core\Features\Plugins\Interface_Plugin;
use WPRuby_CAA\Core\Features\Plugins\Plugins_Factory;

class Get_Menu_Endpoint extends Abstract_Endpoint {

	public function callback( $data ) {
		$main_menu    = get_option( Constants::CAA_ALL_MENU_SLUGS );
		$plugins_menu = [];

		$supported_plugins = Plugins_Factory::supported_plugins();
		/** @var Interface_Plugin $plugin */
		foreach ( $supported_plugins as $plugin_key => $plugin ) {
			$plugin = Plugins_Factory::make( $plugin_key );
			if ( $plugin === null ) {
				continue;
			}
			if ( ! $plugin->is_installed() ) {
				continue;
			}

			$plugins_menu[ $plugin->key() ] = [
				'key'  => $plugin->key(),
				'name' => $plugin->name(),
				'menu' => $plugin->menu(),
			];
		}

		$this->output( [
			'main_menu'    => $main_menu,
			'plugins_menu' => $plugins_menu,
		] );
	}

	public function action() {
		return 'get_menu';
	}
}
