<?php

namespace WPRuby_CAA\Core\App\Backend\Endpoints;

use WP_Session_Tokens;
use WPRuby_CAA\Core\Dto\User;

class Logout_User_Endpoint extends Abstract_Endpoint {


	public function callback( $data ) {

		$user_id = intval($data['user_id']);

		$sessions = WP_Session_Tokens::get_instance($user_id);

		$sessions->destroy_all();

		$user = new User($user_id);

		$user->setIsLoggedIn(false);

		$this->ok();
	}

	public function action()
	{
		return 'logout_user';
	}
}
